Package org.apache.commons.math3.distribution

# Class ConstantRealDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.ConstantRealDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class ConstantRealDistribution extends AbstractRealDistribution
Implementation of the constant real distribution.

Since:
  3.4
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`ConstantRealDistribution(double value)`
Create a constant real distribution with the given value.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`double`
`inverseCumulativeProbability(double p)`
Computes the quantile function of this distribution.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.
`void`
`reseedRandomGenerator(long seed)`
Override with no-op (there is no generator).
`double`
`sample()`
Generate a random value sampled from this distribution.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, getSolverAbsoluteAccuracy, logDensity, probability, probability, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ConstantRealDistribution

public ConstantRealDistribution(double value)
Create a constant real distribution with the given value.

Parameters:
  `value` - the constant value of this distribution

## Method Details

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### inverseCumulativeProbability

public double inverseCumulativeProbability(double p) throws OutOfRangeException
Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is

- `inf{x in R | P(Xinvalid input: '<'=x) >= p}` for `0 < p <= 1`,
- `inf{x in R | P(Xinvalid input: '<'=x) > 0}` for `p = 0`.

The default implementation returns

- `RealDistribution.getSupportLowerBound()` for `p = 0`,
- `RealDistribution.getSupportUpperBound()` for `p = 1`.

Specified by:
  `inverseCumulativeProbability` in interface `RealDistribution`
Overrides:
  `inverseCumulativeProbability` in class `AbstractRealDistribution`
Parameters:
  `p` - the cumulative probability
Returns:
  the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)
Throws:
  `OutOfRangeException` - if `p < 0` or `p > 1`

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution.

Returns:
  the mean or `Double.NaN` if it is not defined

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

Returns:
  lower bound of the support (might be `Double.NEGATIVE_INFINITY`)

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

Returns:
  upper bound of the support (might be `Double.POSITIVE_INFINITY`)

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support.

Returns:
  whether the support is connected or not

### sample

public double sample()
Generate a random value sampled from this distribution. The default implementation uses the inversion method.

Specified by:
  `sample` in interface `RealDistribution`
Overrides:
  `sample` in class `AbstractRealDistribution`
Returns:
  a random value.

### reseedRandomGenerator

public void reseedRandomGenerator(long seed)
Override with no-op (there is no generator).

Specified by:
  `reseedRandomGenerator` in interface `RealDistribution`
Overrides:
  `reseedRandomGenerator` in class `AbstractRealDistribution`
Parameters:
  `seed` - (ignored)